From 53ea91c98fef614f047e1903b34fcd2a65533c0b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 22:21:36 +0000
Subject: [PATCH 1286/2232] Factor out this_crate initialization


---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 783eb04..deca600 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -177,9 +177,39 @@ impl Project {
 // on the current crate.
 fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Result<Build> {
     let ref prj = Project::init()?;
+    let this_crate = make_this_crate(prj)?;
+    this_crate.print_to_cargo();
+
+    let mut build = Build::new();
+    build.cpp(true);
+    build.cpp_link_stdlib(None); // linked via link-cplusplus crate
+
+    for path in rust_source_files {
+        generate_bridge(prj, &mut build, path.as_ref())?;
+    }
+
+    let mut crates = deps::direct_dependencies();
+    crates.insert(0, this_crate);
+
+    eprintln!("\nCXX include path:");
+    for krate in crates {
+        for header_dir in &krate.header_dirs {
+            build.include(&header_dir.path);
+            if header_dir.exported {
+                eprintln!("  {}", header_dir.path.display());
+            } else {
+                eprintln!("  {} (private)", header_dir.path.display());
+            }
+        }
+    }
 
+    Ok(build)
+}
+
+fn make_this_crate(prj: &Project) -> Result<Crate> {
     let crate_dir = make_crate_dir(prj);
     let include_dir = make_include_dir(prj)?;
+
     let mut this_crate = Crate {
         include_prefix: Some(prj.include_prefix.clone()),
         links: env::var_os("CARGO_MANIFEST_LINKS"),
@@ -194,12 +224,14 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
         exported: true,
         path: include_dir,
     });
+
     if let Some(crate_dir) = crate_dir {
         this_crate.header_dirs.push(HeaderDir {
             exported: true,
             path: crate_dir,
         });
     }
+
     for exported_dir in &CFG.exported_header_dirs {
         if !exported_dir.is_absolute() {
             return Err(Error::ExportedDirNotAbsolute(exported_dir));
@@ -209,32 +241,8 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
             path: PathBuf::from(exported_dir),
         });
     }
-    this_crate.print_to_cargo();
-
-    let mut build = Build::new();
-    build.cpp(true);
-    build.cpp_link_stdlib(None); // linked via link-cplusplus crate
-
-    for path in rust_source_files {
-        generate_bridge(prj, &mut build, path.as_ref())?;
-    }
-
-    let mut crates = deps::direct_dependencies();
-    crates.insert(0, this_crate);
 
-    eprintln!("\nCXX include path:");
-    for krate in crates {
-        for header_dir in &krate.header_dirs {
-            build.include(&header_dir.path);
-            if header_dir.exported {
-                eprintln!("  {}", header_dir.path.display());
-            } else {
-                eprintln!("  {} (private)", header_dir.path.display());
-            }
-        }
-    }
-
-    Ok(build)
+    Ok(this_crate)
 }
 
 fn make_crate_dir(prj: &Project) -> Option<PathBuf> {

